use embedded_hal::digital::blocking::OutputPin;

pub struct DcOutController<T: OutputPin> {
    pub state: bool,
    pin: T,
}

impl<T> DcOutController<T>
where
    T: OutputPin,
{
    pub fn new(pin: T) -> DcOutController<T> {
        return DcOutController { state: false, pin };
    }

    pub fn on(&mut self) -> Result<(), T::Error> {
        self.state = true;
        return self.pin.set_low();
    }
    pub fn off(&mut self) -> Result<(), T::Error> {
        self.state = false;
        return self.pin.set_high();
    }
}
